/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package storage.impl.database;

import database.connection.ConnectionFactory;
import domain.Invoice;
import domain.InvoiceItem;
import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import storage.StorageInvoice;

/**
 *
 * @author student1
 */
public class StorageDatabaseInvoice implements StorageInvoice {

    @Override
    public Invoice save(Invoice invoice) throws Exception {
        Connection connection = ConnectionFactory.getInstance().getConnection();
        // connection : setAutoCommit = false
        String upit = "INSERT INTO Invoice (created_date,amount) VALUES (?,?)";
        PreparedStatement preparedStatement = connection.prepareStatement(upit, Statement.RETURN_GENERATED_KEYS);
        preparedStatement.setDate(1, new Date(invoice.getCreatedDate().getTime()));
        preparedStatement.setBigDecimal(2, invoice.getAmount());
        preparedStatement.executeUpdate();
        ResultSet rs = preparedStatement.getGeneratedKeys();

        if (rs.next()) {
            Long invoiceID = rs.getLong(1);
            invoice.setId(invoiceID);
            upit = "INSERT INTO Invoice_item (invoice_id,order_no,quantity,price,product_id) VALUES (?,?,?,?,?)";
            preparedStatement = connection.prepareStatement(upit);
            for (InvoiceItem invoiceItem : invoice.getInoviceItems()) {
                preparedStatement.setLong(1, invoice.getId());
                preparedStatement.setLong(2, invoiceItem.getOrderNo());
                preparedStatement.setLong(3, invoiceItem.getQuantity());
                preparedStatement.setBigDecimal(4, invoiceItem.getPrice());
                preparedStatement.setLong(5, invoiceItem.getProduct().getId());
                preparedStatement.executeUpdate();
            }
            connection.commit(); // TODO: commit uraditi u servis metodi
            
        } else {
            connection.rollback();
            throw new Exception("Error in creating invoice id!");
        }
        
        return invoice;
    }

}
